package com.zksy.controller.property;

import cn.hutool.core.date.DateTime;
import com.zksy.property.domain.AAssetManagement;
import com.zksy.property.domain.AMaintenance;
import com.zksy.property.service.AAssetManagementService;
import com.zksy.property.service.AMaintenanceService;
import com.zksy.utils.AjaxResult;
import com.zksy.utils.ExcelExportUtil;
import com.zksy.utils.ExcelImportUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Arrays;

/**
 * @author Administrator
 * @version 1.0
 * @project enterprise-assets-service
 * @description 维修管理控制层
 * @date 2025/6/24 14:33:13
 */
@RestController
@RequestMapping("/amaintenance")
@Api(tags = "维修管理信息",description = "维修管理信息desc")
public class AMaintenanceController {
    @Autowired
    private AMaintenanceService service;
    @GetMapping("/findByPage")
    @ApiOperation(value = "维修管理信息查询分页")
    public AjaxResult findByPage(long pageNum, long pageSize, String assetCode,String equipmentName,String taskTitle,String taskStatus){
        return AjaxResult.success(service.findByPage(pageNum, pageSize, assetCode,equipmentName,taskTitle,taskStatus));
    }
    @GetMapping("/getAMaintenanceList")
    @ApiOperation(value = "维修管理信息查询")
    public AjaxResult getAAssetManagementList(String assetCode,String equipmentName,String taskTitle,String taskStatus){
        return AjaxResult.success(service.getAMaintenanceList(assetCode,equipmentName,taskTitle,taskStatus));
    }
    @GetMapping("/getById/{id}")
    @ApiOperation(value = "根据Id查询维修管理信息")
    public AjaxResult getById(@PathVariable String id){
        return AjaxResult.success(service.getById(id));
    }
    @PostMapping("/save")
    @ApiOperation(value = "维修管理信息保存")
    public AjaxResult save(@RequestBody AMaintenance amaintenance) {
        return service.save(amaintenance) ? AjaxResult.success(amaintenance) : AjaxResult.error("保存失败");
    }
    @PostMapping("/update")
    @ApiOperation(value = "维修管理信息修改")
    public AjaxResult update(@RequestBody AMaintenance amaintenance) {
        amaintenance.setUpdateTime(LocalDateTime.now());
        return service.updateById(amaintenance) ? AjaxResult.success(amaintenance) : AjaxResult.error("修改失败");
    }
    @PostMapping("/deleteBatch")
    @ApiOperation(value = "维修管理信息删除")
    public AjaxResult delete(@RequestBody String[] ids) {
        return service.removeBatchByIds(Arrays.asList(ids)) ? AjaxResult.success("删除成功") : AjaxResult.error("删除失败");
    }
    @PostMapping("/importData")
    @ApiOperation(value = "导入数据")
    public AjaxResult importData(MultipartFile file) {
        return AjaxResult.success(service.saveOrUpdateBatch(ExcelImportUtil.importExcel(file, AMaintenance.class)));
    }
    @GetMapping("/exportData")
    @ApiOperation(value = "导出数据")
    public void exportData(HttpServletResponse response,String assetCode,String equipmentName,String taskTitle,String taskStatus) {
        ExcelExportUtil.exportExcel(response,service.getAMaintenanceList(assetCode,equipmentName,taskTitle,taskStatus), AMaintenance.class, "维修管理信息","维修管理信息");
    }

}
